#line 1 "C:/Users/Mohamed/Desktop/Codes for FC/F&T_Meter/CODE/CODE.c"






sbit LCD_RS at RC6_bit;
sbit LCD_EN at RC7_bit;
sbit LCD_D4 at RD4_bit;
sbit LCD_D5 at RD5_bit;
sbit LCD_D6 at RD6_bit;
sbit LCD_D7 at RD7_bit;

sbit LCD_RS_Direction at TRISC6_bit;
sbit LCD_EN_Direction at TRISC7_bit;
sbit LCD_D4_Direction at TRISD4_bit;
sbit LCD_D5_Direction at TRISD5_bit;
sbit LCD_D6_Direction at TRISD6_bit;
sbit LCD_D7_Direction at TRISD7_bit;




char Freq_txt[11];
unsigned int tmr1_Val=0;
unsigned int OverNumb=0;
unsigned long Freq=0;
unsigned short tmr0_cnt=100;
bit flag;
char TPer_txt[15];
float TPer=0;

void _Init()
{
 trisd.f0=0;
 lcd_init();
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Cmd(_LCD_CLEAR);


 intcon.f7=1;
 intcon.f6=1;
 intcon.f5=1;
 OPTION_REG.T0CS = 0;
 OPTION_REG.PSA = 0;
 OPTION_REG.PS2 = 1; OPTION_REG.PS1 = 1; OPTION_REG.PS0 = 1;
 tmr0_cnt=100;
 tmr0=139;



 PIE1.f0=1;
 t1con.f1=1;
 t1con.f3=1;
 t1con.f2=1;
 tmr1l=0; tmr1h=0;
}



void interrupt()
{

 if(intcon.f2==1)
 {
 if(tmr0_cnt--==1)
 { portb.f0= ~portb.f0;
 intcon.f7=0; t1con.f0=0;
 flag=1;
 }

 intcon.f2=0;
 tmr0=139;
 }

 if(pir1.f0==1)
 {
 OverNumb++;
 pir1.f0=0;
 }

}




void main()
{ trisb=0;
portb=0x00;
 _Init();

 lcd_out(1,1, "FrequencyMeter");
 for(;;)
 {
 if(flag==1)
 {
 tmr1_Val = (TMR1H << 8) + TMR1L;
 Freq = tmr1_Val;
 LongWordToStr(Freq,Freq_txt);
 floatToStr(TPer,TPer_txt);
 lcd_out(2,1, Freq_txt); lcd_out_cp("Hz");
 tmr1l=0; tmr1h=0; tmr1_Val=0; OverNumb=0; Freq=0; TPer=0;
 tmr0_cnt=100; flag=0;

 intcon.f7=1; t1con.f0=1;
 }
 }
}
